#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>

#include <common.h>
#include <error.h>

#define LOGFILENAMEMAXLEN 20
#define TMPBUFSIZE 150

char logfilename[LOGFILENAMEMAXLEN]="error.log";

void ErrSetLogName(char *logfile)
{
  if (logfile[0]!=0) {
    strncpy(logfilename,logfile,LOGFILENAMEMAXLEN);
    logfilename[LOGFILENAMEMAXLEN-1]=0; /* TO be sure */
  }
}

void _ErrLog(char *text, char *file, int line)
{
  int len;
  int fd;
  char tmpbuf[TMPBUFSIZE];

  len=sprintf(tmpbuf,"[%s:%d] ",file,line);
  if (len>=TMPBUFSIZE) {
    ErrError("TMPBUFSIZE in error.c is to small!!");
  }
  fd=open(logfilename,OPEN_WRITE_TEXT_APPEND,S_IREAD|S_IWRITE);
  if (fd<0)
    ErrError("Can't open logfile");
  write(fd,tmpbuf,len);
  write(fd,text,strlen(text));
  write(fd,"\n",1);
  close(fd);
}

void _ErrWarning(char *text, char *file, int line)
{
  int len;
  int fd;
  char tmpbuf[TMPBUFSIZE];

  len=sprintf(tmpbuf,"[%s:%d] Warning: ",file,line);
  if (len>=TMPBUFSIZE) {
    ErrError("TMPBUFSIZE in error.c is to small!!");
  }
  fd=open(logfilename,OPEN_WRITE_TEXT_APPEND,S_IREAD|S_IWRITE);
  if (fd<0)
    ErrError("Can't open logfile");
  write(fd,tmpbuf,len);
  write(fd,text,strlen(text));
  write(fd,"\n",1);
  close(fd);
}

void _ErrError(char *text, char *file, int line)
{
  int len;
  int fd;
  char tmpbuf[TMPBUFSIZE];

  len=sprintf(tmpbuf,"[%s:%d] **ERROR**: ",file,line);
  if (len>=TMPBUFSIZE) {
    printf("****[General Error]**** TMPBUFSIZE in error.c is to small!!\n");
  }
  fd=open(logfilename,OPEN_WRITE_TEXT_APPEND,S_IREAD|S_IWRITE);
  if (fd<0) {
    printf("****[General Error]**** Can't open logfile: %s\n",strerror(errno));
  }
  write(fd,tmpbuf,len);
  write(fd,text,strlen(text));
  write(fd,"\n",1);
  close(fd);
  printf("%s%s\n",tmpbuf,text);
  raise(SIGABRT);
  exit(1);
}

void _assert(char *test,char *file, int line)
{
  int len;
  char tmpbuf[TMPBUFSIZE];

  len=sprintf(tmpbuf,"assert(%s) failed",test);
  if (len>=TMPBUFSIZE) {
    tmpbuf[TMPBUFSIZE-1]=0;
    _ErrLog(tmpbuf,file,line); /* log, not error. Error would terminate */
    ErrError("TMPBUFSIZE in error.c is to small!!");
  }
  _ErrError(tmpbuf,file,line);
}

void _verify(char *test,char *file, int line)
{
  int len;
  char tmpbuf[TMPBUFSIZE];

  len=sprintf(tmpbuf,"verify(%s) failed",test);
  if (len>=TMPBUFSIZE) {
    tmpbuf[TMPBUFSIZE-1]=0;
    _ErrLog(tmpbuf,file,line); /* log, not error. Error would terminate*/
    ErrError("TMPBUFSIZE in error.c is to small!!");
  }
  _ErrError(tmpbuf,file,line);
}
