#ifndef FASTMEM_H
#define FASTMEM_H

#include <stdlib.h>


#include "vector.h"
#include <object.h>
#include <zobject.h>

enum memtype {
 MEM_ZFLATPOLY=0,
 MEM_ZGOROUDPOLY,
 MEM_ZTEXTUREPOLY
};

struct MemBlock {
  struct MemBlock *next;
};

extern size_t objsize[3];
extern struct MemBlock *Head[3];

extern INLINE void *MemGet(enum memtype type)
#ifdef HAS_INLINE
{
  struct MemBlock *ptr;
  if (Head[type]!=0) {
    ptr=Head[type];
    Head[type]=ptr->next;
    return ((unsigned char *)ptr)+sizeof(struct MemBlock);
  } else {
    ptr=malloc(objsize[type]+sizeof(struct MemBlock));
    if (ptr)
      return ((unsigned char *)ptr)+sizeof(struct MemBlock);
    else 
      return 0;
  }
}
#else
;
#endif

extern INLINE void MemLeave(void *vptr,enum memtype type)
#ifdef HAS_INLINE
{
  struct MemBlock *ptr;
  ptr=(struct MemBlock *) vptr - 1;
  ptr->next=Head[type];
  Head[type]=ptr;
}
#else
;
#endif

#endif /* FASTMEM_H */
