#ifndef RENDER_H
#define RENDER_H
#include <zobject.h>

extern byte *ColorTransform;
int InitRenderer(void);

void RenderZObject(ZObject *ZObj);

signed_32bit Ceil28_4(signed_32bit fract);
signed_32bit Mult28_4(signed_32bit a,signed_32bit b);
void FloorDivMod(signed_32bit numerator,signed_32bit denominator,
		 signed_32bit *floor,signed_32bit *mod);
void TraceEdge(signed_32bit *start,signed_32bit *end,int right,int datadim);
void RenderPoly(signed_32bit *poly,int dim, byte ClockWise);
void RenderFlatPoly(ZFlatPoly *poly);
void RenderGoroudPoly(ZGoroudPoly *poly);
void RenderGoroudLine(byte *ptr,int len,
		      signed_32bit Int,signed_32bit dInt,
		      byte *coltfm );
void RenderDot(ZDot *dot);
void RenderLine(ZLine *line);
void RenderTexturePoly(ZTexturePoly *poly);

extern signed_32bit *scanlines; /* Contains startx,endx for all scanlines */
extern fixedpoint *scanlinedata; /* Contains other data for lines (u,v,c..) */
extern fixedpoint GradientX[MAXDATADIM];
extern fixedpoint GradientY[MAXDATADIM];

#endif /* RENDER_H */
